
#include <windows.h>
#include <windowsx.h> 

#include <commctrl.h>
#include <commdlg.h>
#include <winuser.h>


#include <vfw.h>

#include "recavi.h"


AVISTREAMINFO si;
BITMAPINFOHEADER *bmih;
PAVIFILE pavi;
PAVISTREAM pstm,ptmp;
unsigned long sizeimage, imagecounter, s=0;
unsigned char *databuffer=NULL;
RGBQUAD *paldata=NULL;
AVICOMPRESSOPTIONS opt;
LPAVICOMPRESSOPTIONS popt;
COMPVARS cv;


int recavifilestart(int w, int h, unsigned char *pal){
//	si={streamtypeVIDEO,comptypeDIB,0,0,0,0,1,30,0,LENG,0,0,(DWORD)-1,0,{0,0,WIDTH,HEIGHT},0,0,_T("Video #1")};
//	bmih={sizeof(BITMAPINFOHEADER),WIDTH,HEIGHT,1,24,BI_RGB,SIZEIMAGE,0,0,0,0};
	ZeroMemory(&si, sizeof(AVISTREAMINFO));
//	si.fccType = streamtypeVIDEO;
//	si.fccHandler = comptypeDIB;
	si.dwScale = 1;
	si.dwRate = 60;
	si.dwLength = 10;
	si.dwQuality = (DWORD)-1;
	si.rcFrame.top = 0;
	si.rcFrame.left = 0;
	si.rcFrame.right = w;
	si.rcFrame.bottom = h;
	strcpy(si.szName, "Video #1");

	bmih = (BITMAPINFOHEADER *)malloc(sizeof(BITMAPINFOHEADER) + (256 * sizeof(RGBQUAD)));
	if(bmih==NULL)
		return 0;
	imagecounter=0;
	sizeimage = w*h;
	databuffer = (unsigned char *)malloc(sizeimage * 3);
	paldata = (RGBQUAD *)malloc((256 * sizeof(RGBQUAD)));
	if(databuffer==NULL || paldata ==NULL)
		return 0;
	bmih->biSize = sizeof(BITMAPINFOHEADER);
    bmih->biWidth           = w; 
    bmih->biHeight          = h; 
    bmih->biPlanes          = 0x0001; 
    bmih->biBitCount        = 24; //8;
    bmih->biCompression     = BI_RGB;   
    bmih->biSizeImage       = sizeimage;
    bmih->biXPelsPerMeter   = 0; //0x60; 
    bmih->biYPelsPerMeter   = 0; //0x60;
    bmih->biClrUsed         = 0; //0x100; 
    bmih->biClrImportant    = 0; //0x100;
//	memcpy(&bmih[sizeof(BITMAPINFOHEADER)], pal, (256 * sizeof(RGBQUAD)));
	memcpy(paldata, pal, (256 * sizeof(RGBQUAD)));

	memset(&cv,0,sizeof(COMPVARS));
	cv.cbSize=sizeof(COMPVARS);
	cv.dwFlags=ICMF_COMPVARS_VALID;
	cv.fccHandler=comptypeDIB;
	cv.lQ=ICQUALITY_DEFAULT;

	if (!ICCompressorChoose(NULL,ICMF_CHOOSE_DATARATE | ICMF_CHOOSE_KEYFRAME | ICMF_CHOOSE_ALLCOMPRESSORS,&bmih,NULL,&cv,NULL))
		return 0;
	AVIFileInit();
	si.fccHandler=cv.fccHandler;
	si.fccType = cv.fccType;
/*
	si.dwRate = cv.hic;
	si.dwLength = 10;
	si.dwQuality = (DWORD)-1;
*/
	opt.fccType=cv.fccType; //streamtypeVIDEO;
	opt.fccHandler=cv.fccHandler;
	opt.dwKeyFrameEvery=cv.lKey;
	opt.dwQuality=cv.lQ;
	opt.dwBytesPerSecond=cv.lDataRate;
	opt.dwFlags=(cv.lDataRate>0?AVICOMPRESSF_DATARATE:0)
										|(cv.lKey>0?AVICOMPRESSF_KEYFRAMES:0);
	opt.lpFormat=NULL;
	opt.cbFormat=0;
	opt.lpParms=cv.lpState;
	opt.cbParms=cv.cbState;
	opt.dwInterleaveEvery=0;

	if(AVIFileOpen(&pavi, "TESTX.AVI",OF_CREATE | OF_WRITE | OF_SHARE_DENY_NONE,NULL)!=0)
		return 0;
	if(AVIFileCreateStream(pavi,&pstm,&si)!=0)
		return 0;
	if(AVIMakeCompressedStream(&ptmp,pstm,&opt,NULL)!=AVIERR_OK)
		return 0;

	if(AVIStreamSetFormat(pstm, 0, bmih, sizeof(BITMAPINFOHEADER)/*+ (256 * sizeof(RGBQUAD))*/) !=0)
		return 0;
	free(bmih);
	return 1;
}



void recavifilerelease(){
//	AVISaveOptionsFree(s,popt);
	AVIStreamRelease(ptmp);
	AVIStreamRelease(pstm);
	AVIFileRelease(pavi);
	ICCompressorFree(&cv);
	AVIFileExit();
	free(databuffer);
}


void recavifilewriteflame(unsigned char *ip, int w, int h){
	int i, x=w>>1, d;
	unsigned char *p=databuffer;

	for(i=0; i<h; ++i){
		for(int j=0; j<x; ++j){
			d = ip[i*w+j];
			*p++=paldata[d].rgbBlue;
			*p++=paldata[d].rgbGreen;
			*p++=paldata[d].rgbRed;
		}
	}

	if(AVIStreamWrite(pstm, imagecounter, 1, databuffer, sizeimage, AVIIF_KEYFRAME, NULL, NULL)!=0)
		return;
	++imagecounter;
	return;
}
